searchNodes=[{"doc":"","ref":"SnapFramework.Parser.Layout.html","title":"SnapFramework.Parser.Layout","type":"module"},{"doc":"","ref":"SnapFramework.Parser.Layout.html#build_child_list/2","title":"SnapFramework.Parser.Layout.build_child_list/2","type":"function"},{"doc":"","ref":"SnapFramework.Parser.Layout.html#parse/1","title":"SnapFramework.Parser.Layout.parse/1","type":"function"},{"doc":"","ref":"SnapFramework.Parser.Layout.html#run/1","title":"SnapFramework.Parser.Layout.run/1","type":"function"},{"doc":"Overview SnapFramework.Component is nearly identical to a Scene. The main different is the addition of the defcomponent macro, as well as the addition of the scenic opts key. defcomponent build out your scenic validate function and helper functions, automatically so you don't have to. defmodule Example.Component.MyComponent do use SnapFramework.Component , name : :my_component , template : &quot;lib/scenes/my_component.eex&quot; , controller : :none , assigns : [ ] , opts : [ ] defcomponent :my_component , :tuple end The above example defines a component that takes in a tuple for data. and build your helper function defined as my_component/3 Templates Component templates also have an additional feature that primitives or scene templates do not have. You can inject children into them. Lets write a basic icon button component that takes an icon child. # template &lt; % = graph font_size : 20 % &gt; &lt; % = primitive Scenic.Primitive.Circle , 15 , id : :bg , translate : { 23 , 23 } % &gt; @children # component module defmodule Example.Component.IconButton do use SnapFramework.Component , name : :icon_button , template : &quot;lib/icons/icon_button/icon_button.eex&quot; , controller : :none , assigns : [ ] , opts : [ ] defcomponent :icon_button , :any end Now lets see how to use this component with children in a scene. This assumes we've already made an icon component. &lt; % = graph font_size : 20 % &gt; &lt; % = component Example.Component.IconButton , nil , id : :icon_button do % &gt; &lt; % = component Example.Component.Icon , @icon , id : :icon % &gt; &lt; % end % &gt; That's all there is to putting children in components!","ref":"SnapFramework.Component.html","title":"SnapFramework.Component","type":"module"},{"doc":"","ref":"SnapFramework.Component.html#defcomponent/2","title":"SnapFramework.Component.defcomponent/2","type":"macro"},{"doc":"Overview SnapFramework.Scene aims to make creating Scenic scenes easier and comes with a lot of convenient features. See Scenic.Scene docs for more on scenes. In order to use this module you will first need a template. Templates are just basic EEx files. See an example template below &lt; % = graph font_size : 20 % &gt; &lt; % = primitive Scenic.Primitive.Text , &quot;selected value \#{ @dropdown_value } &quot; , id : :dropdown_value_text , translate : { 20 , 80 } % &gt; &lt; % = component Scenic.Component.Dropdown , { @dropdown_opts , @dropdown_value } , id : :dropdown , translate : { 20 , 20 } % &gt; We always start the template off with &lt;%= graph %&gt; . This tells the compiler to build the Scenic graph. After that we begin inserting our primitives or components. The above is equivilent to writing the following - Scenic.Graph . build ( ) |&gt; Scenic.Primitive.Text . add_to_graph ( &quot;selected value \#{ scene . assigns . dropdown_value } &quot; , id : :dropdown_value_text , translate : { 20 , 80 } ) |&gt; Scenic.Component.Dropdown ( { scene . assigns . dropdown_opts , scene . assigns . dropdown_value } , id : :dropdown , translate : { 20 , 20 } ) Now that we have a template we can use the template in a scene. defmodule Example.Scene.MyScene do use SnapFramework.Scene , name : :my_scene , template : &quot;lib/scenes/my_scene.eex&quot; , controller : :none , assigns : [ dropdown_opts : [ { &quot;Dashboard&quot; , :dashboard } , { &quot;Controls&quot; , :controls } , { &quot;Primitives&quot; , :primitives } ] , dropdown_value : :dashboard , ] end Having just the above should be enough to get the scene rendering. But as you can see selecting a new dropdown doesn't update the text component text like the template implies that it should. To update a graph SnapFramework has the use_effect macro. This macro comes with a Scene or Component. Let's update the above code to catch the event from the dropdown and update the text. defmodule Example.Scene.MyScene do use SnapFramework.Scene , name : :my_scene , template : &quot;lib/scenes/my_scene.eex&quot; , controller : Example.Scene.MySceneController , assigns : [ dropdown_opts : [ { &quot;Dashboard&quot; , :dashboard } , { &quot;Controls&quot; , :controls } , { &quot;Primitives&quot; , :primitives } ] , dropdown_value : :dashboard , ] use_effect [ assigns : [ dropdown_value : :any ] ] , [ run : [ :on_dropdown_value_change ] , ] def process_event ( { :value_changed , :dropdown , value } , _ , scene ) do { :noreply , assign ( scene , dropdown_value : value ) } end end Last but not least the controller module. defmodule Examples.Scene.MySceneController do import Scenic.Primitives , only : [ text : 3 ] alias Scenic.Graph def on_dropdown_value_change ( scene ) do graph = scene . assigns . graph |&gt; Graph . modify ( :dropdown_value_text , &amp; text ( &amp;1 , &quot;selected value \#{ scene . assigns . dropdown_value } &quot; , [ ] ) ) Scenic.Scene . assign ( scene , graph : graph ) end end That is the basics to using SnapFramework.Scene. It essentially consist of three pieces, a template, a controller, and a scene module that glues them together. Setup and Mounted Callbacks If you need to do some special setup, like request input, subscribe to a PubSub service, or add some runtime assigns. You can do that in the setup callback. It gives you the scene struct and should return a scene struct. The setup callback run before the template is compiled. So any added or modified assigns will be included in the template. The graph however is not included on the scene yet. defmodule Example.Scene.MyScene do use SnapFramework.Scene , name : :my_scene , template : &quot;lib/scenes/my_scene.eex&quot; , controller : Example.Scene.MySceneController , assigns : [ dropdown_opts : [ { &quot;Dashboard&quot; , :dashboard } , { &quot;Controls&quot; , :controls } , { &quot;Primitives&quot; , :primitives } ] , dropdown_value : :dashboard , ] use_effect [ assigns : [ dropdown_value : :any ] ] , [ run : [ :on_dropdown_value_change ] , ] def setup ( scene ) do Scenic.PubSub . subscribe ( :pubsub_service ) assign ( scene , new_assign : true ) end def process_event ( { :value_changed , :dropdown , value } , _ , scene ) do { :noreply , assign ( scene , dropdown_value : value ) } end end If you need to do something after the graph is compile, you can use the mounted callback. Like the setup callback it gives you the scene, and should return a scene. defmodule Example.Scene.MyScene do use SnapFramework.Scene , name : :my_scene , template : &quot;lib/scenes/my_scene.eex&quot; , controller : Example.Scene.MySceneController , assigns : [ dropdown_opts : [ { &quot;Dashboard&quot; , :dashboard } , { &quot;Controls&quot; , :controls } , { &quot;Primitives&quot; , :primitives } ] , dropdown_value : :dashboard , ] use_effect [ assigns : [ dropdown_value : :any ] ] , [ run : [ :on_dropdown_value_change ] , ] def setup ( scene ) do Scenic.PubSub . subscribe ( :pubsub_service ) assign ( scene , new_assign : true ) end def mounted ( %{ assigns : %{ graph : graph } } = scene ) do # do something with the graph end def process_event ( { :value_changed , :dropdown , value } , _ , scene ) do { :noreply , assign ( scene , dropdown_value : value ) } end end","ref":"SnapFramework.Scene.html","title":"SnapFramework.Scene","type":"behaviour"},{"doc":"Called after graph is compiled. If you need to do any post setup changes on your graph do that here.","ref":"SnapFramework.Scene.html#c:mounted/1","title":"SnapFramework.Scene.mounted/1","type":"callback"},{"doc":"Called when a scene receives a call message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_call/3","title":"SnapFramework.Scene.process_call/3","type":"callback"},{"doc":"Called when a scene receives an cast message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_cast/2","title":"SnapFramework.Scene.process_cast/2","type":"callback"},{"doc":"Called when a scene receives an event message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_event/3","title":"SnapFramework.Scene.process_event/3","type":"callback"},{"doc":"Called when a scene receives a message. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_info/2","title":"SnapFramework.Scene.process_info/2","type":"callback"},{"doc":"Called when a scene receives an input messsage. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_input/3","title":"SnapFramework.Scene.process_input/3","type":"callback"},{"doc":"Called when a scene receives an update message. Use this to update data and options on your state. The returned state is diffed, and effects are run.","ref":"SnapFramework.Scene.html#c:process_update/3","title":"SnapFramework.Scene.process_update/3","type":"callback"},{"doc":"Called when a first starts, before the graph is compiled. Use this to do any startup logic. Any assigns set or updated here will be included in the compiled graph. If you need to subscribe to a PubSub service do that here.","ref":"SnapFramework.Scene.html#c:setup/1","title":"SnapFramework.Scene.setup/1","type":"callback"},{"doc":"The use effect macro glues your scene module to your controller. Whenever you return a scene from the on of the process functions, it matches against your effect registery. If a match is found it then runs the specified controller function and pushed your graph if your graph has changed use_effect [ assigns : [ dropdown_value : :any ] ] , [ run : [ :on_dropdown_value_change ] , ]","ref":"SnapFramework.Scene.html#use_effect/2","title":"SnapFramework.Scene.use_effect/2","type":"macro"},{"doc":"The watch macro will recompile the template with the most up to date assigns, whenever one of the watched keys changes. This macro is not recommended for large scene or components. use_effect is always preferred. watch [ :dropdown_value ]","ref":"SnapFramework.Scene.html#watch/1","title":"SnapFramework.Scene.watch/1","type":"macro"},{"doc":"The EEx template engine. Overview The SnapFramework Engine is responsible for parsing EEx templates and building graphs from them. You should always start a template with the a graph, and then add any components and primitives immediately after it. &lt; % = graph font_size : 20 % &gt; &lt; % = component Scenic.Component.Button , &quot;button text&quot; , id : :btn % &gt; &lt; % = primitive Scenic.Primitive.Rectangle , { 100 , 100 } , id : :rect , fill : :steel_blue % &gt; In the above example you can see how simple it is to render component and primitives. Layouts The templating engine also supports layouts. &lt; % = graph font_size : 20 % &gt; &lt; % = layout padding : 100 , width : 600 , height : 600 , translate : { 100 , 10 } do % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = component Scenic.Component.Button , &quot;test btn&quot; , id : :test_btn % &gt; &lt; % = layout padding : 0 , width : 600 , height : 300 , translate : { 10 , 10 } do % &gt; &lt; % = component Scenic.Component.Input.Dropdown , { @dropdown_opts , @dropdown_value } , id : :dropdown_1 , z_index : 100 % &gt; &lt; % = component Scenic.Component.Input.Dropdown , { @dropdown_opts , @dropdown_value } , id : :dropdown_2 % &gt; &lt; % end % &gt; &lt; % end % &gt; The only required options on templates are width and height . Any nested layouts will have the padding and translate of the previous layout added onto it. Any components rendered within a layout are added directly to the graph. Which means you can modify them directly in the scene you're working in. There is no parent component that is rendered.","ref":"SnapFramework.Engine.html","title":"SnapFramework.Engine","type":"module"},{"doc":"","ref":"SnapFramework.Engine.html#compile/4","title":"SnapFramework.Engine.compile/4","type":"function"},{"doc":"","ref":"SnapFramework.Engine.html#compile_string/4","title":"SnapFramework.Engine.compile_string/4","type":"function"},{"doc":"","ref":"SnapFramework.Engine.html#encode_to_iodata!/1","title":"SnapFramework.Engine.encode_to_iodata!/1","type":"function"},{"doc":"Overview This module is responsible for taking the parsed EEx template and building the graph.","ref":"SnapFramework.Engine.Builder.html","title":"SnapFramework.Engine.Builder","type":"module"},{"doc":"","ref":"SnapFramework.Engine.Builder.html#build_graph/2","title":"SnapFramework.Engine.Builder.build_graph/2","type":"function"}]